:: ASSEMBLE.BAT (for MS-DOS).
:: HP48 and HP49G SysRPL/ML Compile/Assemble individual programs.
:: Args: source file [input], binary object file [output].
:: E.g.  ASSEMBLE  MYPROG.RPL  MYPROG.BIN  [command line]
::
:: Performs RPLCOMP, SASM, and SLOAD.
:: All intermediate files are temporary.
:: You get to see each output listing, to check for errors.
:: If you cancel with ^C, the temporary files remain;
:: otherwise all intermediate files are deleted at end of script.
::
:: Automaticallly generates the "HPHP48-x" binary file header for you.
:: Source file should *not* contain %%HP.. header or any string quotes.
:: Note differences between RPLCOMP and Jazz from Jazz documentation.
:: Assumes that you have the program LIST.COM from GD#9, 10, or 11
:: (press ESC or X  to exit from the LIST.COM program).
:: Remove references to "find" or use "grep" if you have older MS-DOS.
:: Adjust to your own setup wherever you see the word EDIT.
::
@ echo off

:: Give help if argument(s) missing:
if "%1"=="" goto help
if "%2"=="" goto help
if "%3"=="" goto help

echo.
echo.Assembling "%1" (output "%2" & "%3")

:: Display input file info:
echo.
dir %1 | find ":"
if not exist %1 goto help
dir %2 | find ":"
dir %3 | find ":"
echo.
pause

::  Path to executables and other files:
::  EDIT me (directory containing HP tools):
set pat=d:\hp48\tools\
set SASM_LIB=%pat%
::  Program for displaying text files [get it off Goodies disks]:
set list=LIST.COM

::  Temporary directory and files:
set tmp=c:\temp
set tms=%tmp%\temphp48.s
set tma=%tmp%\temphp48.a
set tmm=%tmp%\temphp48.m
set tml=%tmp%\temphp48.l
set tmo=%tmp%\temphp48.o
set tmr=%tmp%\temphp48.r

:: Environment space test:
if not "%tmr%"=="%tmp%\temphp48.r" goto end

:: Temporary directory:
if not exist %tmp%\nul md %tmp%
if not exist %tmp%\nul goto end

:: Compile HP48 version (automatically inserting the HPHP48-x header)

echo.> %tms%
echo.TITLE %1 >> %tms%
echo.ASSEMBLE >> %tms%
echo.        NIBASC \HPHP48-Q\ >> %tms%
echo.RPL >> %tms%
type %1 >> %tms%

%pat%\RPLCOMP %tms% %tma%
%list% %tma%

:: Assemble output of above

%pat%\SASM %tma%
%list% %tml%

:: Load output of above

echo.> %tmm%
echo.TITLE %1 >> %tmm%
echo.OUTPUT %2 >> %tmm%
echo.LLIST %tmr% >> %tmm%
echo.SUPPRESS XREF >> %tmm%
::   EDIT according to which symbol files you use (see below):
rem  SEARCH %pat%\ENTRIES.O >> %tmm%
::   Above file is obsoleted by newer from www.hut.fi/~mheiskan
echo.SEARCH %pat%\SUPROMENTR.O >> %tmm%
rem echo.SEARCH %pat%\USERENTR.O >> %tmm%
:: Generate symbol files via: SASM SUPROMEN.A (makes SUPROMEN.O)
echo.REL %tmo% >> %tmm%
echo.END >> %tmm%

%pat%\SLOAD -H %tmm%
%list% %tmr%

:: Compile HP49G version (automatically inserting the HPHP49-x header)

echo.> %tms%
echo.TITLE %1 >> %tms%
echo.ASSEMBLE >> %tms%
echo.        NIBASC \HPHP49-Q\ >> %tms%
echo.RPL >> %tms%
type %1 >> %tms%

%pat%\RPLCOMP %tms% %tma%
%list% %tma%

:: Assemble output of above

%pat%\SASM %tma%
%list% %tml%

:: Load output of above

echo.> %tmm%
echo.TITLE %1 >> %tmm%
echo.OUTPUT %3 >> %tmm%
echo.LLIST %tmr% >> %tmm%
echo.SUPPRESS XREF >> %tmm%
echo.SEARCH %pat%\SUPROM49.o >> %tmm%
:: Generate symbol files via: SASM SUPROMEN.A (makes SUPROMEN.O)
echo.REL %tmo% >> %tmm%
echo.END >> %tmm%

%pat%\SLOAD -H %tmm%
%list% %tmr%

echo.
echo.Final files:

echo.
dir %1 | find ":"
dir %2 | find ":"
dir %3 | find ":"
echo.
type %tml% | find "ERROR"
pause

goto end

: help
echo.
echo.To assemble HP48 and HP49 SysRPL input to binary output file:
echo.
echo.  %0  input_file  hp48_output_file hp49_output_file
echo.

: end

:: Delete temporary files (unless ^C has terminated execution):
if exist %tms% del %tms%
if exist %tma% del %tma%
if exist %tmm% del %tmm%
if exist %tml% del %tml%
if exist %tmo% del %tmo%
if exist %tmr% del %tmr%

:: Delete environment variables:

set pat=
set SASM_LIB=
set list=
set tmp=

set tms=
set tma=
set tmm=
set tml=
set tmo=
set tmr=

:: bye
